; RegisterEventSource.asm  Writes an event log in the Application section
;                          CONSOLE program
.686
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\advapi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\advapi32.lib

.data

OutputBuffer	BYTE	512 dup(0)
Provider_Name	BYTE	'The provider', 0
Failed          	BYTE	'Failure, Register Event Function Returned %d.',0
Success		BYTE	'Success, Register Event Function Returned %d.', 0
AppName         	BYTE	'SiegeWorks 2011',0

;                      Unicode created by UniString.exe
stringpointers	WORD "T","h","i","s"," ","i","s"," ","a","n"," ","e","x","a","m","p","l","e"
                  WORD  "."," ","S","i","e","g","e","W","o","r","k","s"," ","2","0","1","1",0

p_string_input	DWORD	0

.DATA?

hEventLog       		HWND	?
dwEventDataSize		WORD	?

.code

start:
	invoke RegisterEventSource, 0, ADDR Provider_Name
	mov hEventLog, EAX
	call Display_Return_Message
	lea	EAX, stringpointers
	mov	p_string_input, EAX
	invoke ReportEvent, hEventLog, \		; handle to log file
		1, \				            ; EVENTLOG_ERROR_TYPE
		2, \						; DATABASE_CATEGORY
		0C0000101H, \				; MSG_BAD_FILE_CONTENTS the event ID
		0, \						; NULL
		1, \						; number input strings
		0, \						; number bytes to write in word value or 0
		ADDR p_string_input, \			; ADDRess of strings
		0						; pointer to binary data or NULL
	call Display_Return_Message
	invoke DeregisterEventSource, hEventLog
	call Display_Return_Message
	invoke ExitProcess, NULL

Display_Return_Message proc

	.if EAX == 0
		pusha
		invoke GetLastError
		invoke wsprintf, ADDR OutputBuffer, ADDR Failed, EAX
		invoke  MessageBox, 0, ADDR OutputBuffer, ADDR AppName, 0
		popa
	.endif

	.if EAX != 0
		invoke wsprintf, ADDR OutputBuffer, ADDR Success, EAX
		invoke  MessageBox, 0, ADDR OutputBuffer, ADDR AppName, 0
	.endif
	ret

Display_Return_Message endp

END start